% This function calculates the value function for the grid defined by
% flowgrid. This flowgrid contains flow values, and endlow and endhigh
% contain boundary values.

function out=FindValueFunction(flowgrid,disc,probup,endlow,endhigh,stopcrit);

stopnow=0;
itermax=100000;

valuegrid=flowgrid;
valuegrid=zeros(size(valuegrid));
iternum=1;
while stopnow==0,
    valueold=valuegrid;
    valuegrid(1)=flowgrid(1)+probup*disc*valueold(2)+(1-probup)*disc*endlow;
    valuegrid(end)=flowgrid(end)+probup*disc*endhigh+(1-probup)*disc*valueold(end-1);
    for ind=2:length(valuegrid)-1,
        valuegrid(ind)=flowgrid(ind)+probup*disc*valueold(ind+1)+(1-probup)*disc*valueold(ind-1);
    end
    stoptest=norm(valuegrid-valueold);
    if stoptest<stopcrit || iternum>itermax,
        stopnow=1;
    end
    if iternum>itermax,
        warning('value did not converge');
    end
    iternum=iternum+1;
    valueold=valuegrid;
end

out=valuegrid;